//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D40493502E8.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D40493502E8.cm

//## begin module%3D40493502E8.cp preserve=no
//## end module%3D40493502E8.cp

//## Module: SwitchParam%3D40493502E8; Package specification
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/SwitchParam.h

#ifndef SWITCHPARAM_H
#define SWITCHPARAM_H 1

//## begin module%3D40493502E8.additionalIncludes preserve=no
//## end module%3D40493502E8.additionalIncludes

//## begin module%3D40493502E8.includes preserve=yes
//## end module%3D40493502E8.includes

// Parameter
#include <XSModel/Parameter/Parameter.h>
//## begin module%3D40493502E8.declarations preserve=no
//## end module%3D40493502E8.declarations

//## begin module%3D40493502E8.additionalDeclarations preserve=yes
//## end module%3D40493502E8.additionalDeclarations


//## begin SwitchParam%38EB53DB0C78.preface preserve=yes
//## end SwitchParam%38EB53DB0C78.preface

//## Class: SwitchParam%38EB53DB0C78; protected
//## Category: XSModel::Parameter%36349D8902D7
//## Subsystem: XSModel::Parameter%367691A8CEA0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class SwitchParam : public Parameter  //## Inherits: <unnamed>%38EB53F2AD48
{
  //## begin SwitchParam%38EB53DB0C78.initialDeclarations preserve=yes
  //## end SwitchParam%38EB53DB0C78.initialDeclarations

  public:
    //## Constructors (generated)
      SwitchParam(const SwitchParam &right);

    //## Constructors (specified)
      //## Operation: SwitchParam%3A92A25E0229
      SwitchParam (const string& initString = "", ComponentBase* p = 0	// Token for parent component instance for grabbing
      	// initialization data etc. Since there are (gain)
      	// parameters that do not have a component parent this is
      	// a pointer rather than a reference as used for the same
      	// concept for ComponentGroup and Component.
      );

    //## Destructor (generated)
      virtual ~SwitchParam();


    //## Other Operations (specified)
      //## Operation: clone%38EB56D380B0
      virtual SwitchParam* clone (ComponentBase* p) const;

      //## Operation: put%38EB6698DB80
      virtual std::ostream& put (std::ostream& s) const;

      //## Operation: value%39009207E360
      virtual Real value () const;

      //## Operation: stringVal%3CEC00B501B9
      //	Operation supporting the XSPEC tclout command which
      //	simply writes the data members of the parameter to a
      //	string.
      virtual string stringVal () const;

      //## Operation: parameterSetting%3F2E79DB0116
      virtual string parameterSetting () const;

    // Additional Public Declarations
      //## begin SwitchParam%38EB53DB0C78.public preserve=yes
      //## end SwitchParam%38EB53DB0C78.public

  protected:

    //## Other Operations (specified)
      //## Operation: compare%38EB882D5120
      virtual bool compare (const Parameter& right) const;

      //## Operation: link%38F642691A98
      virtual void link (const string& toLink);

    // Additional Protected Declarations
      //## begin SwitchParam%38EB53DB0C78.protected preserve=yes
      //## end SwitchParam%38EB53DB0C78.protected

  private:
    //## Assignment Operation (generated)
      SwitchParam & operator=(const SwitchParam &right);


    //## Other Operations (specified)
      //## Operation: init%38ECDA0E3B78
      virtual void init (const string& initString);

      //## Operation: changeValue%38F642390998
      virtual void changeValue (const string& parString);

      //## Operation: setValue%3900945BC410
      void setValue (int state);

      //## Operation: doPreserve%3C0FD49902E8
      virtual void doPreserve ();

    // Additional Private Declarations
      //## begin SwitchParam%38EB53DB0C78.private preserve=yes
      //## end SwitchParam%38EB53DB0C78.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: state%38EB578DD898
      //## begin SwitchParam::state%38EB578DD898.attr preserve=no  private: int {U} 0
      int m_state;
      //## end SwitchParam::state%38EB578DD898.attr

    // Additional Implementation Declarations
      //## begin SwitchParam%38EB53DB0C78.implementation preserve=yes
      //## end SwitchParam%38EB53DB0C78.implementation

};

//## begin SwitchParam%38EB53DB0C78.postscript preserve=yes
//## end SwitchParam%38EB53DB0C78.postscript

// Class SwitchParam 

//## begin module%3D40493502E8.epilog preserve=yes
//## end module%3D40493502E8.epilog


#endif
